Bug 1001008 - Review Request: CImg - C++ Template Image Processing Toolkit
Review Request: CImg - C++ Template Image Processing Toolkit
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Daniel Berrange
Fedora Extras Quality Assurance
:
: 852898 (view as bug list)
Depends On:
Blocks: 1061801
  Show dependency treegraph
 
Reported: 2013-08-26 05:54 EDT by Christopher Meng
Modified: 2014-07-03 00:09 EDT (History)
5 users (show)

See Also:
Fixed In Version: CImg-1.5.8-2.fc19
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2014-07-03 00:01:14 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
berrange: fedora‑review+
kevin: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Christopher Meng 2013-08-26 05:54:52 EDT
Spec URL: http://cicku.me/cimg.spec
SRPM URL: http://cicku.me/cimg-1.5.6-1.fc21.src.rpm        
Description: The CImg Library is an open-source C++ toolkit for image processing. 
It consists in a single header file 'CImg.h' providing a minimal set of C++ 
classes and methods that can be used in your own sources, to load/save, 
process and display images. Very portable, efficient, easy to use, 
it's a pleasant library for developping image processing algorithms in C++.
Fedora Account System Username: cicku
Comment 1 Christopher Meng 2013-10-26 00:40:27 EDT
I will change the name to CImg to match the tarball name, update spec/srpm will be uploaded later.
Comment 2 Christopher Meng 2013-10-26 00:41:11 EDT
*** Bug 852898 has been marked as a duplicate of this bug. ***
Comment 3 Ralf Corsepius 2014-02-07 02:12:27 EST
Any update?

Please reflect FPC's recent decisions on "HeaderOnlyLibraries" (We voted, write-up is still missing) to this packages:
- Convert from "noarch" to "arch".
- Build the examples as part of %check.
- Implement https://fedoraproject.org/wiki/OrionPoplawski/HeaderLibrariesDraft.
Comment 4 Ralf Corsepius 2014-02-17 05:54:34 EST
(In reply to Ralf Corsepius from comment #3)
> Any update?
No response from submitter for 10 days. I am closing this review request as dead.
Comment 5 Daniel Berrange 2014-04-24 09:17:29 EDT
This blocks the GMIC package review (bug 1061801)


The SRPM + SPEC listed in the initial description are both returning 404's - can you re-upload them. If you don't have time to finish the changes requird, I'd be happy to take over doing the changes needed to complete review, so I can unblock GMIC.
Comment 6 Christopher Meng 2014-04-30 03:46:37 EDT
I will fix this bug soo, currently fftw ldflags are incorrectly-linked, and causes examples built failed.(Ralf asked me to build them to ensure if they are usable)
Comment 7 Christopher Meng 2014-05-05 05:29:06 EDT
I figured out that CMake only finds -lfftw3, without fftw3_threads the linking process will not be finished.


SPEC URL: http://misc.cicku.me/fedora/CImg.spec
SRPM URL: http://misc.cicku.me/fedora/CImg-1.5.8-1.fc21.src.rpm
Comment 8 Daniel Berrange 2014-06-13 04:22:12 EDT
I've tried to look at this a few times but the server is constantly offline. Today I see it is back but now giving 404 for those links. Could you upload them somewhere that's more reliably available like fedorapeople.org then I can review it.
Comment 9 Christopher Meng 2014-06-18 05:49:43 EDT
I have problem using SSH recently, including HTTPS sites, therefore I uploaded the SRPM to MEGA:

https://mega.co.nz/#!HJRQCSgC!i_qxTTAElkb1J-BgyY0KnZtPir9rPIK5xA_fyZ9HiCc
Comment 10 Daniel Berrange 2014-06-18 07:26:14 EDT
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated

Issues:
=======
- Large documentation must go in a -doc subpackage. Large could be size (~1MB)
  or number of files.
  Note: Documentation size is 1269760 bytes in 4 files.
  See: http://fedoraproject.org/wiki/Packaging/Guidelines#PackageDocumentation

This is due to the /usr/share/doc/CImg-devel/CImg_reference.pdf file. I think it is reasonable to leave that as part of the main -devel RPM, and not move it to -doc. 1 MB is still small compared to the overall size of the toolchain required to use CImg.


===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Header files in -devel subpackage, if present.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[!]: License field in the package spec file matches the actual license.

While most files are CeCILL licensed as per the spec, the file
/usr/include/CImg/plugins/cimgmatlab.h is LGPL licensed - no mention
of which version though. 

[!]: If the package is under multiple licenses, the licensing breakdown must
     be documented in the spec.

Missing mention of LGPL

[x]: Package requires other packages for directories it uses.
[!]: Package must own all directories that it creates.

Doesn't own the dir /usr/include/CImg

[-]: %build honors applicable compiler flags or justifies otherwise.

Doesn't honour compiler flags, but only things compiled are examples
used as part of %check, which are not distributed, so can ignore this.

[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[-]: Useful -debuginfo package or justification otherwise.
[-]: Package is not known to require an ExcludeArch tag.
[c]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[!]: Rpmlint is run on all rpms the build produces.

Incorrect Source0 URL

[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[-]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[!]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.
===== EXTRA items =====

Generic:
[x]: Spec file according to URL is the same as in SRPM.
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
[x]: Rpmlint is run on all installed packages.



Rpmlint
-------
Checking: CImg-devel-1.5.8-1.fc20.x86_64.rpm
          CImg-1.5.8-1.fc20.src.rpm
CImg-devel.x86_64: W: file-not-utf8 /usr/share/doc/CImg-devel/Licence_CeCILL_V2-en.txt
CImg-devel.x86_64: W: file-not-utf8 /usr/share/doc/CImg-devel/Licence_CeCILL-C_V1-en.txt
CImg.src: W: spelling-error %description -l en_US developping -> developing, develop ping, develop-ping
CImg.src: W: invalid-url Source0: http://downloads.sourceforge.net/project/CImg/CImg-1.5.8.zip HTTP Error 302: The HTTP server returned a redirect error that would lead to an infinite loop.
The last 30x error message was:
Found
2 packages and 0 specfiles checked; 0 errors, 4 warnings.


The RPM lint warning about Source0 is correct, the URL prefix should be '/project/cimg/' not '/project/CImg/' - in the .spec change '/project/%{name}/' to '/project/cimg/'

So in summary

 - Fix Source0 URL
 - Fix license to include LGPL
 - Change %{_includedir}/%{name}/plugins to %{_includedir}/%{name} in %files
Comment 11 Christopher Meng 2014-06-23 04:19:47 EDT
Fixed at(SRPM): https://mega.co.nz/#!SVhDkSTR!BXgm1tx1B__tIPQnXUWZ6_mMUFCqvsKyt68tkRTwI80
Comment 12 Daniel Berrange 2014-06-23 05:45:51 EDT
All issues addressed -> approved.
Comment 13 Christopher Meng 2014-06-23 06:13:48 EDT
New Package SCM Request
=======================
Package Name: CImg
Short Description: C++ Template Image Processing Toolkit
Owners: cicku
Branches: f20 f19
Comment 14 Kevin Fenzi 2014-06-23 13:04:40 EDT
Git done (by process-git-requests).
Comment 15 Fedora Update System 2014-06-23 23:54:24 EDT
CImg-1.5.8-2.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/CImg-1.5.8-2.fc20
Comment 16 Fedora Update System 2014-06-23 23:54:33 EDT
CImg-1.5.8-2.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/CImg-1.5.8-2.fc19
Comment 17 Fedora Update System 2014-06-24 19:24:13 EDT
CImg-1.5.8-2.fc19 has been pushed to the Fedora 19 testing repository.
Comment 18 Fedora Update System 2014-07-03 00:01:14 EDT
CImg-1.5.8-2.fc20 has been pushed to the Fedora 20 stable repository.
Comment 19 Fedora Update System 2014-07-03 00:09:32 EDT
CImg-1.5.8-2.fc19 has been pushed to the Fedora 19 stable repository.

Note You need to log in before you can comment on or make changes to this bug.